#include "httpd.h"
#include "http_config.h"
#include "http_protocol.h"
#include "http_log.h"
#include "ap_config.h"

#include <fcntl.h>
#include <sys/types.h>
#include <unistd.h>

#include "blosxom.h"

static int sort_revcmp(const void *a, const void *b)
{
    blosxom_entry *e1 = *(blosxom_entry **)a;
    blosxom_entry *e2 = *(blosxom_entry **)b;
    if (e1->mtime < e2->mtime)
        return -1;
    if (e1->mtime > e2->mtime)
        return 1;
    else
        return 0;
}

static int reverse_sort(blosxom_context_rec *ctx)
{
    qsort(ctx->entries->elts, ctx->entries->nelts,
          sizeof(blosxom_entry *), sort_revcmp);
    return OK;
}

blosxom_plugin revsort_blosxom_plugin = {
    BLOSXOM_PLUGIN_STUFF,   /* mod_blosxom plugin stuff (NOT EDIT) */
    NULL,                   /* start function                      */
    NULL,                   /* template load function              */
    NULL,                   /* find weblog entry function          */
    NULL,                   /* filter entry function               */
    NULL,                   /* end function                        */
    NULL,                   /* skip entry function                 */
    NULL,                   /* interpolate function                */
    NULL,                   /* head function                       */
    reverse_sort,           /* sort entry function                 */
    NULL,                   /* date format function                */
    NULL,                   /* story function                      */
    NULL,                   /* foot function                       */
    NULL                    /* last function                       */
};
